// This sample illustrates use of the BreakIterator class

import java.text.*;
import java.util.*;

class BreakDemo {

	static String string = 
	  "He said \"How tall are you?\" and I said I'm 5\'5\" tall, etc.";
	static BreakIterator boundary;

  public static void main(String args[]) {


	 	//print each word
	 	boundary = BreakIterator.getWordInstance(Locale.getDefault());
	 	boundary.setText(string);
		printBreaks("word");

    //print each sentence
	 	boundary = BreakIterator.getSentenceInstance(Locale.getDefault());
	 	boundary.setText(string);
		printBreaks("sentence");
 }

 static void printBreaks(String type) {
	 	int start = boundary.first();
		int end = boundary.next();
	 	while (end != BreakIterator.DONE) {
			 String part = string.substring(start,end);
			 if (!part.equals(" "))
			 	 System.out.println(part + " is a " + type);
			 start = end;
			 end = boundary.next();
	 }

 }
}  
	
