	//----------------------------------------------------------------------------
	// Method to sort a vector of strings
	// This sort uses CollationKeys, where are about 10 times faster than using Collator.compare
	// This is true even including the overhead of setting up the extra arrays, etc.
	// It is a simple bubble sort, which is faster than other algorithms
	// for very small vectors and for vectors that are almost in order already
// This sample illustrates use of CollationKey class

import java.text.*;
import java.util.*;

class SortDemo {

	static Vector v = new Vector();

  public static void main(String args[]) {
	  v.addElement("Dan");
		v.addElement("Alice");
		v.addElement("Liza");
		v.addElement("Edward");
		v.addElement("Zane");
	 	v = sort(v);
		for (int i=0; i<v.size(); i++)
		  System.out.println(v.elementAt(i));
  }

	public static Vector sort (Vector unsorted) {
	  CollationKey temp;
		int i,j;
		int size = unsorted.size();
		Vector sorted = new Vector(size);

		Collator collator = Collator.getInstance(Locale.getDefault());
		CollationKey[] keys = new CollationKey[size];
		for (i=0; i<size; i++)
			keys[i] = collator.getCollationKey((String)(unsorted.elementAt(i)));
		for (i=0; i<size; i++)
			for (j=i; j<size; j++)
				if( keys[i].compareTo( keys[j] ) > 0 ) {
					temp = keys[j];
					keys[j] = keys[i];
					keys[i] = temp;
				}    
		for (i=0; i<size; i++)
			sorted.addElement(keys[i].getSourceString());
		return sorted;
	}
}