/*

FaultDetectedMessage.java

*/

package cs141b.gndo;

import info.net.Place;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

public class FaultDetectedMessage extends DataContainingMessage {
  private Place _failedWorker;

  public FaultDetectedMessage() {
    super();
    _failedWorker = null;
  }

  public FaultDetectedMessage(Place from, Path where, Place failedWorker) {
    super(from, where);

    Assert.isNotNull(failedWorker);

    _failedWorker = failedWorker;
  }

  public Place failedWorker() {
    return _failedWorker;
  }

  public void readData(DataInputStream dis) throws IOException {
    super.readData(dis);
    _failedWorker = (Place)readObject(dis);

    Assert.isNotNull(_failedWorker);
  }

  public void writeData(DataOutputStream dos) throws IOException {
    Assert.isNotNull(_failedWorker);

    super.writeData(dos);
    _failedWorker.writeObject(dos);
  }
};
