/*

GiveLockMessage.java

*/

package cs141b.gndo;

import info.net.Place;
import java.util.Vector;

public class GiveLockMessage extends DataContainingMessage {
  private Vector _wantLockQueue;

  public GiveLockMessage() {
    super();
    _wantLockQueue = null;
  }

  public GiveLockMessage(Place from, Vector wantLockQueue, Path where) {
    super(from, where);
    
    _wantLockQueue = new Vector();

    if (wantLockQueue != null) {
      for(int i=0;i<wantLockQueue.size();++i) {
        _wantLockQueue.addElement(wantLockQueue.elementAt(i));
      }
    }
  }

  public Vector wantLockQueue() {
    return _wantLockQueue;
  }

  public void readData(java.io.DataInputStream dis) throws java.io.IOException {
    super.readData(dis);
    
    int len = dis.readInt();
    Assert.isTrue(len >= 0);
    _wantLockQueue = new Vector(len);
    for(int i=0;i<len;++i) {
      _wantLockQueue.addElement(readObject(dis));
    }
  }

  public void writeData(java.io.DataOutputStream dos) throws java.io.IOException {
    super.writeData(dos);

    Assert.isNotNull(_wantLockQueue);
    dos.writeInt(_wantLockQueue.size());
    for(int i=0;i<_wantLockQueue.size();++i) {
      ((Message)_wantLockQueue.elementAt(i)).writeObject(dos);
    }
  }
};
