/*

JoinMessage.java - A message to all nodes saying that somebody new has joined.
Contains an update on the NDO

*/

package cs141b.gndo;

import info.net.Place;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

public class JoinMessage extends Message {
  private DataContainingMessage _ndoUpdate;

  public JoinMessage() {
    super();
    _ndoUpdate = null;
  }

  public JoinMessage(Place from, DataContainingMessage ndoUpdate) {
    super(from);
    _ndoUpdate = ndoUpdate;
  }

  public DataContainingMessage ndoUpdate() {
    return _ndoUpdate;
  }

  public void readData(DataInputStream dis) throws IOException {
    super.readData(dis);

    _ndoUpdate = (DataContainingMessage)readObject(dis);
    Assert.isNotNull(_ndoUpdate);
  }

  public void writeData(DataOutputStream dis) throws IOException {
    super.writeData(dis);

    Assert.isNotNull(_ndoUpdate);
    _ndoUpdate.writeObject(dis);
  }
};
