/*

LeaveStartedMessage.java - Message to all nodes asking them to tell
the leaving node to send us a list of fields they think it's the best
guess for

*/

package cs141b.gndo;

import info.net.Place;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

public class LeaveStartedMessage extends Message {
  private DataContainingMessage _ndoUpdate;

  public LeaveStartedMessage() {
    super();
    _ndoUpdate = null;
  }

  public LeaveStartedMessage(Place from, DataContainingMessage ndoUpdate) {
    super(from);
    _ndoUpdate = ndoUpdate;
  }

  public DataContainingMessage ndoUpdate() {
    return _ndoUpdate;
  }

  public void readData(DataInputStream dis) throws IOException {
    super.readData(dis);

    _ndoUpdate = (DataContainingMessage)readObject(dis);
    Assert.isNotNull(_ndoUpdate);
  }

  public void writeData(DataOutputStream dis) throws IOException {
    super.writeData(dis);

    Assert.isNotNull(_ndoUpdate);
    _ndoUpdate.writeObject(dis);
  }
};
