/*

PathList.java

*/

package cs141b.gndo;

import java.util.Vector;

class PathList extends Vector {
  private int _prevAddIndex;

  public PathList() {
    _prevAddIndex = -1;
  }

  public void add(Path path) {
    int left = 0;
    int right = size();

    // Speed check - See if the added element is immediately after the previous
    // element added

    if (_prevAddIndex != -1) {
      int comp = path.compare((Path)elementAt(_prevAddIndex));

      if (comp < 0) {
        right = _prevAddIndex;
      } else if (comp > 0) {
        left = _prevAddIndex+1;

        if (left < size()) {
          comp = path.compare((Path)elementAt(left));
          if (comp < 0) {
            right = left;
          } else if (comp == 0) {
            Assert.isTrue(comp == 0);
            Assert.error("Attempt to add element to PathList twice!");
          }
        }
      } else {
        Assert.isTrue(comp == 0);
        Assert.error("Attempt to add element to PathList twice!");
      }
    }

    // Do a binary search to find insert position

    while(left < right) {
      int middle = (left+right)/2;

      int comp = path.compare((Path)elementAt(middle));
      if (comp < 0) {
        right = middle;
      } else if (comp > 0) {
        left = middle+1;
      } else {
        Assert.isTrue(comp == 0);
        Assert.error("Attempt to add element to PathList twice!");
      }
    }

    // We've found the insert position

    Assert.isTrue(left == right);

    insertElementAt(path, left);

    _prevAddIndex = left;
  }
};
