/*

RequestBetterGuessesMessage.java - The message from a node sent to the person who's leaving,
asking for who we should reassign our best guesses to for a list of fields

*/

package cs141b.gndo;

import info.net.Place;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

public class RequestBetterGuessesMessage extends Message {
  private PathList _whichFieldsGaveLock;
  private PathList _whichFieldsBestGuesses;

  public RequestBetterGuessesMessage() {
    super();
  }

  public RequestBetterGuessesMessage(Place from, 
                                     PathList whichFieldsGaveLock,
                                     PathList whichFieldsBestGuesses) {
    super(from);
    _whichFieldsGaveLock = whichFieldsGaveLock;
    _whichFieldsBestGuesses = whichFieldsBestGuesses;
  }

  public PathList whichFieldsGaveLock() {
    return _whichFieldsGaveLock;
  }

  public PathList whichFieldsBestGuesses() {
    return _whichFieldsBestGuesses;
  }

  public void readData(DataInputStream dis) throws IOException {
    super.readData(dis);
    int len = dis.readInt();
    _whichFieldsGaveLock = new PathList();
    for(int i=0;i<len;++i) {
      _whichFieldsGaveLock.add((Path)readObject(dis));
    }
    len = dis.readInt();
    _whichFieldsBestGuesses = new PathList();
    for(int i=0;i<len;++i) {
      _whichFieldsBestGuesses.add((Path)readObject(dis));
    }
  }

  public void writeData(DataOutputStream dos) throws IOException {
    super.writeData(dos);
    dos.writeInt(_whichFieldsGaveLock.size());
    for(int i=0;i<_whichFieldsGaveLock.size();++i) {
      ((Path)_whichFieldsGaveLock.elementAt(i)).writeObject(dos);
    }
    dos.writeInt(_whichFieldsBestGuesses.size());
    for(int i=0;i<_whichFieldsBestGuesses.size();++i) {
      ((Path)_whichFieldsBestGuesses.elementAt(i)).writeObject(dos);
    }
  }
};
