/*

SharedInt.java

*/

package cs141b.gndo;

import java.io.DataOutputStream;
import java.io.DataInputStream;
import java.io.IOException;

public class SharedInt extends SharedVar {
  int _data;

  SharedInt() {
    super();
    _data = 0;
  }

  public SharedInt(SharedContainer parent) {
    super(parent);
    _data=0;
  }
  
  /** <override> read the integer from a stream */
  public synchronized void readData(DataInputStream dis) throws IOException {
    _data=dis.readInt();
  }

  /** <override> Write the integer to a stream */
  public synchronized void writeData(DataOutputStream dos) throws IOException {
    dos.writeInt(_data);
  }

  /**Set a new value for the int*/
  public synchronized void set(int data) {
    if (!locked()) {
      throw new FieldNotLockedException("SharedInt not locked.");
    }
    if (_data != data) {
      _data=data;
      setModified();
    }
  }

  /**Get the value of the integer */
  public synchronized int get() {
    return _data;
  }

}
