/*

SharedString.java

*/

package cs141b.gndo;

import java.io.DataOutputStream;
import java.io.DataInputStream;
import java.io.IOException;

public class SharedString extends SharedVar {
  String _data;

  public SharedString(SharedContainer parent) {
    super(parent);
    _data="";
  }

  SharedString() {
    _data="";
  }
  
  /** <override> read the string from a stream */
  public synchronized void readData(DataInputStream dis) throws IOException {
    int len = dis.readInt();
    StringBuffer buf = new StringBuffer(len);
    for(int i=0;i<len;++i) {
      buf.append(dis.readChar());
    }
    _data = buf.toString();
  }

  /** <override> Write the string to a stream */
  public synchronized void writeData(DataOutputStream dos) throws IOException {
    dos.writeInt(_data.length());
    dos.writeChars(_data);
  }

  /**Set a new value for the string*/
  public synchronized void set(String data) {
    if (!locked()) {
      throw new FieldNotLockedException("SharedString not locked.");
    }
    if (!_data.equals(data)) {
      _data=data;
      setModified();
    }
  }

  /**Get the value of the string */
  public synchronized String get() {
    return _data;
  }

}
