/*

TestNDO.java

*/

package cs141b.gndo;

public class TestNDO extends NDO {
  SharedInt _i;
  SharedString _str;

  public TestNDO() {
    super();
  }

  public TestNDO(info.net.Place joinTo) {
    super(joinTo);
  }

  public void makeFields() {
    _i = new SharedInt(this);
    _str = new SharedString(this);
  }

  public SharedInt i() {
    return _i;
  }

  public SharedString str() {
    return _str;
  }

  public static void main(String args[]) {
    TestNDO ndo;

    if (args.length == 0) {
      ndo = new TestNDO();
      ndo.unlockAll();
    } else {
      ndo = new TestNDO(new info.net.Place(args[0]));
    }
    System.out.println("Hello, world join at: '"+ndo.where()+"'");

    boolean done = false;
    java.io.DataInputStream in = new java.io.DataInputStream(System.in);

    try {
      while(!done) {
        int curValue = ndo.i().get();
        String curString = ndo.str().get();
        
        System.out.println("Current == "+curValue+"("+ndo.i().currentState()+") CurString == '"+curString+"'("+ndo.str().currentState()+") new?");
        String inLine = in.readLine();
        if (inLine.equals("q")) {
          done = true;
        } else if (inLine.equals("+")) {
          ndo.startLock();
          ndo.i().lock();
          try {
            ndo.completeLock();
          }
          catch(FieldDeletedException e) {
            Assert.error("Bad thing happened");
          }
          int newValue = ndo.i().get();
          if (newValue != curValue) {
            System.out.println("Whoops! Value was changed by somebody else to "+newValue);
          } else {
            System.out.println("Value stayed constant at "+newValue);
          }
          ++newValue;
          ndo.i().set(newValue);
          System.out.println("Set value to "+newValue);
          ndo.i().unlock();
        } else if (!inLine.equals("")) {
          ndo.startLock();
          ndo.str().lock();
          try {
            ndo.completeLock();
          }
          catch(FieldDeletedException e) {
            Assert.error("Bad thing happened");
          }
          String newString = ndo.str().get();
          if (!newString.equals(curString)) {
            System.out.println("String changed by somebody else to '"+newString+"'");
          } else {
            System.out.println("String stayed constant at '"+newString+"'");
          }
          ndo.str().set(inLine);
          System.out.println("Set string to "+inLine);
          ndo.str().unlock();
        }
      }

      ndo.leave();
    }
    catch(java.io.IOException e) {
      Assert.error("IOException: "+e.toString());
    }

    System.out.println("Exiting");
  }
};
