/*

WantUpdateMessage.java

*/

package cs141b.gndo;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import info.net.Place;

public class WantUpdateMessage extends VarMessage {
  private long _currentState;

  public WantUpdateMessage() {
    super();
    _currentState = -1;
  }

  public WantUpdateMessage(Place from, Path which, long currentState) {
    super(from, which);
    _currentState = currentState;
  }

  public long currentState() {
    return _currentState;
  }

  public void readData(DataInputStream dis) throws IOException {
    super.readData(dis);
    _currentState = dis.readLong();
  }

  public void writeData(DataOutputStream dos) throws IOException {
    super.writeData(dos);
    dos.writeLong(_currentState);
  }
};
