/*

tn.java

*/

package cs141b.gndo;

public class tn2 extends NDO {
  SharedVector _ints;

  public tn2() {
    super();
  }

  public tn2(info.net.Place joinTo) {
    super(joinTo);
  }

  public void makeFields() {
    _ints = new SharedVector(this);
  }

  public SharedVector ints() {
    return _ints;
  }

  public SharedInt i(int index) throws FieldDeletedException {
    return (SharedInt)_ints.field(index);
  }

  public static void main(String args[]) {
    tn2 ndo;

    if (args.length == 0) {
      ndo = new tn2();
    } else {
      ndo = new tn2(new info.net.Place(args[0]));
    }
    System.out.println("Hello, world join at: '"+ndo.where().toString()+"'");

    boolean done = false;
    java.io.DataInputStream in = new java.io.DataInputStream(System.in);

    String inLine = "x";

    try {
      while(!done) {
        if (!inLine.equals("")) {
          System.out.println(ndo.ints().size()+" numbers, state == "+ndo.ints().currentState());
        }
        inLine = in.readLine();
        if (inLine.equals("q")) {
          done = true;
        } else if (inLine.equals("p")) {
          while(true) {
            try {
              ndo.startLock();
              ndo.ints().lockAll();
              ndo.completeLock();
              break;
            }
            catch(FieldDeletedException e) {
            }
          }
              
          System.out.print("[");
          
          for(int i=0;i<ndo.ints().size();++i) {
            if (i>0) System.out.print(" ");
            System.out.print(((SharedInt)ndo.ints().elementAt(i)).get());
          }
          System.out.println("]");
          
          ndo.ints().unlockAll();
        } else if (inLine.equals("p2")) {
          System.out.print("[");

          for(int i=0;i<ndo.ints().size();++i) {
            if (i>0) System.out.print(" ");
            System.out.print(((SharedInt)ndo.ints().elementAt(i)).get());
          }
          System.out.println("]");
        } else if (inLine.charAt(0) == '+') {
          try {
            int inValue = Integer.parseInt(inLine.substring(1));

            ndo.startLock();
            ndo.ints().lock();
            try {
              ndo.completeLock();
            }
            catch(FieldDeletedException e) {
              Assert.error("Field that shouldn't be deleted was");
            }
            
            SharedInt newInt = new SharedInt(ndo.ints());
            newInt.set(inValue);
            System.out.println("New integer "+inValue+" added");

            ndo.ints().unlock();
            newInt.unlock();
          }
          catch(NumberFormatException e) {
          }
        } else if (inLine.charAt(0) == '-') {
          try {
            int inIndex = Integer.parseInt(inLine.substring(1));

            try {
              ndo.startLock();
              ndo.ints().lock();
              ndo.ints().elementAt(inIndex).lock();
              ndo.completeLock();
              ndo.ints().removeElementAt(inIndex);
              System.out.println("Field at "+inIndex+" deleted");

              ndo.ints().unlock();
            }
            catch(FieldDeletedException e) {
              System.out.println("Pointless to delete field at "+inIndex+" as it has already been deleted!");
            }            
          }
          catch(NumberFormatException e) {
          }
        }
      }

      ndo.leave();
    }
    catch(java.io.IOException e) {
      Assert.error("IOException: "+e.toString());
    }

    System.out.println("Exiting");
  }
};
