//----------------------------------------------------------------------
// Event Printer
// by Louis Thomas
// Last modified: 5-25-97
package cs141b.sedit2;

import java.awt.Event;

//----------------------------------------------------------------------
// The event printer class
public class EventPrinter {

	//------------------------------------------------------------------
	// Anti-Constructor
	private EventPrinter() {
		Assert.error("EventPrinter not instantiable");
	}

	//------------------------------------------------------------------
	// print useful info about an event
	public static void printEvent(Event event) {
		if (event.id==Event.MOUSE_MOVE) {
			return;
		}
		System.out.print(0!=(event.modifiers&Event.ALT_MASK)?"A":"a");
		System.out.print(0!=(event.modifiers&Event.CTRL_MASK)?"C":"c");
		System.out.print(0!=(event.modifiers&Event.META_MASK)?"M":"m");
		System.out.print(0!=(event.modifiers&Event.SHIFT_MASK)?"S":"s");
		System.out.print(" ");
		switch (event.id) {
		case Event.ACTION_EVENT:
			System.out.print("ACTION_EVENT");
			break;
		case Event.GOT_FOCUS:
			System.out.print("GOT_FOCUS");
			break;
		case Event.KEY_ACTION:
			System.out.print("KEY_ACTION");
			break;
		case Event.KEY_ACTION_RELEASE:
			System.out.print("KEY_ACTION_RELEASE");
			break;
		case Event.KEY_PRESS:
			System.out.print("KEY_PRESS");
			break;
		case Event.KEY_RELEASE:
			System.out.print("KEY_RELEASE");
			break;
		case Event.LIST_DESELECT:
			System.out.print("LIST_DESELECT");
			break;
		case Event.LIST_SELECT:
			System.out.print("LIST_SELECT");
			break;
		case Event.LOAD_FILE:
			System.out.print("LOAD_FILE");
			break;
		case Event.LOST_FOCUS:
			System.out.print("LOST_FOCUS");
			break;
		case Event.MOUSE_DOWN:
			System.out.print("MOUSE_DOWN");
			break;
		case Event.MOUSE_DRAG:
			System.out.print("MOUSE_DRAG");
			break;
		case Event.MOUSE_ENTER:
			System.out.print("MOUSE_ENTER");
			break;
		case Event.MOUSE_EXIT:
			System.out.print("MOUSE_EXIT");
			break;
		case Event.MOUSE_MOVE:
			System.out.print("MOUSE_MOVE");
			break;
		case Event.MOUSE_UP:
			System.out.print("MOUSE_UP");
			break;
		case Event.SAVE_FILE:
			System.out.print("SAVE_FILE");
			break;
		case Event.SCROLL_ABSOLUTE:
			System.out.print("SCROLL_ABSOLUTE");
			break;
		case Event.SCROLL_LINE_DOWN:
			System.out.print("SCROLL_LINE_DOWN");
			break;
		case Event.SCROLL_LINE_UP:
			System.out.print("SCROLL_LINE_UP");
			break;
		case Event.SCROLL_PAGE_DOWN:
			System.out.print("SCROLL_PAGE_DOWN");
			break;
		case Event.SCROLL_PAGE_UP:
			System.out.print("SCROLL_PAGE_UP");
			break;
		case Event.WINDOW_DEICONIFY:
			System.out.print("WINDOW_DEICONIFY");
			break;
		case Event.WINDOW_DESTROY:
			System.out.print("WINDOW_DESTROY");
			break;
		case Event.WINDOW_EXPOSE:
			System.out.print("WINDOW_EXPOSE");
			break;
		case Event.WINDOW_ICONIFY:
			System.out.print("WINDOW_ICONIFY");
			break;
		case Event.WINDOW_MOVED:
			System.out.print("WINDOW_MOVED");
			break;
		default:
			System.out.print("Unknown event");
			break;
		}

		System.out.print(" ");
		System.out.print(event.target.getClass().getName());
		System.out.println();
	}

	
}