//----------------------------------------------------------------------
// SEditAboutDialog
// by Louis Thomas
// Last modified: 6-3-97

package cs141b.sedit2;

import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Color;
import java.awt.Dialog;
import java.awt.Event;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.Panel;

//----------------------------------------------------------------------
// The About... dialog class
public class SEditAboutDialog extends Dialog {

	//------------------------------------------------------------------
	// Member Variables
	private Button m_btnOK;

	//------------------------------------------------------------------
	// Constructor
	public SEditAboutDialog(SEdit parent) {
		super(parent, "About SimulEdit", true);

		Panel pBottom=new Panel();
		m_btnOK=new Button("  OK  ");
		pBottom.add(m_btnOK);

		Label lbl=new Label("SimulEdit");
		lbl.setFont(new Font("Helvetica", Font.BOLD, 20));
		lbl.setAlignment(Label.CENTER);


		Panel pCenter=new Panel();
		pCenter.setLayout(new GridLayout(4,1,0,0));
		pCenter.add(new Label("Version 1.1"));
		pCenter.add(new Label("By Sean Suchter"));
		pCenter.add(new Label("and Louis Thomas"));
		pCenter.add(new Label("CS141bc, Caltech"));

		add("North", lbl);
		add("Center", pCenter);
		add("South", pBottom);

		setBackground(Color.lightGray);
		resize(170,150);
		setResizable(false);
		//pack();
		show();
	}

	//------------------------------------------------------------------
	// Handle show
	public void show() {
		super.show();
		m_btnOK.requestFocus();
	}

	//------------------------------------------------------------------
	// Handle an event
	public boolean handleEvent(Event evt) {
		
		//System.out.println("Evt.Target: "+evt.target);

		if (evt.target==this) {
			// Window events
			switch (evt.id) {
			case Event.WINDOW_DESTROY:
				quit();
				return true;
			}			 
		} else if (evt.target==m_btnOK) {
			quit();
			return true;
		} else if (Event.KEY_PRESS==evt.id) {
			if (27==evt.key || 32==evt.key || 13==evt.key || 10==evt.key) {
				quit();
				return true;
			}
		}
		super.handleEvent(evt);
		return true;

	}

	//------------------------------------------------------------------
	// Clean up ASAP.
	private void quit() {
		hide();
		dispose();
		//System.exit(0);
	}
}