/*
 * The Infospheres Infrastructure
 * Copyright (c) 1996,1997 California Institute of Technology.
 * All Rights Reserved.
 */

/*
 *  $Id: TimeoutException.java,v 1.3 1997/04/08 22:17:06 kiniry Exp $
 */

package info.net;


import java.net.*;

/**
 * TimeoutExceptions (or MailDaemonExceptions for long) are those 
 * exceptions which spring from faults and errors in the MailDaemon
 * package.  These exceptions are not lethal.
 */

public class TimeoutException extends SocketException {

  /**
   * Constructs a new TimeoutException with no detail message.
   */
  public TimeoutException( )
  {
    super();
  }

  /**
   * Constructs a new TimeoutException with the specified detail message.
   * The detail message is the String which gives a specific description
   * of the error.  It is accessable via the toString() methid of the super
   * class.
   *
   * @param ex_desc The detail message.
   */
  public TimeoutException( String ex_desc )
  {
    super( ex_desc );
  }

} // end of TimeoutException class
