//
//  StripDebug 1.0
//  Copyright (c) 1997 Matt T. Yourst. All rights reserved.
//
//  File:     StripDebugAttributeCollection.java
//  Classes:  StripDebugAttributeCollection
//  Version:  1.00.035
//  Date:     April/May 1997
//  Author:   Matt Yourst [yourst@laserstars.com]
//  Language: Java 1.1+
//

package lti.java.stripdebug;

import java.io.*;
import java.util.*;
import lti.java.jcf.*;

public class StripDebugAttributeCollection extends JcfAttributeCollection
{
  public StripDebugAttributeCollection (JcfClassInput ist, JcfConstantPool p)
    throws ClassFormatError, IOException { super(ist, p); }

  //
  // Common mistake: any code that modifies the number of attributes must go
  // here (NOT in writeAttribute) since the attribute count is already written
  // when in writeAttribute, and thus will be invalid.
  //
  public void write (JcfClassOutput ost) throws IOException
  {
    String attribName;
    int total = size();
    for (int i = 0; i < total; i++)
    {
      attribName = constPool.utfAt(attributeAt(i).getNameIndex());
      if (attribName.equals("LineNumberTable") ||
        attribName.equals("LocalVariables") ||
        attribName.equals("SourceFile"))
      {
        removeElementAt(i);
        i--;
        total--;
      } 
    }
    super.write(ost);
  }
}
